/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2008 by Witz Corporation, JAPAN
 *  Copyright (C) 2010,2011 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEEρE
 *  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
 *      R[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
 *      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
 *      jAȂǁjɁCL̒쌠\C̗pщL̖
 *      ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
 *      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
 *        邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
 *      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
 *  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
 *  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
 *  ȂD
 * 
 */

/*
 *  M32C/87Ɉˑ`
 */


#ifndef TOPPERS_M32C87_H
#define TOPPERS_M32C87_H

/*
 *  CPUOnhԍ̒`
 */

#define EXCNO_UNDEF_INSTRUNCTION	0	/* ` */
#define EXCNO_OVERFLOW          	1	/* I[o[t[ */
#define EXCNO_BRK_INSTRUCTION   	2	/* BRK */
#define EXCNO_ADDRESS_MATCH     	3	/* AhXv */
#define EXCNO_WDT               	5	/* EHb`hbO^C} */
#define EXCNO_XIN_STOP          	5	/* U~o */
#define EXCNO_LOW_VOLT_DETECT   	5	/* dቺo */
#define EXCNO_NMI                   7	/* NMI */
#define EXCNO_RESET             	8	/* Zbg */

/*
 *  ݔԍ̒`
 */
#define	INTNO_BRK    	0	/* BRK */

#define INTNO_AD1    	7	/* A-Dϊ1 */
#define INTNO_DMA0   	8	/* DMA0 */
#define INTNO_DMA1   	9	/* DMA1 */
#define INTNO_DMA2   	10	/* DMA2 */
#define INTNO_DMA3   	11	/* DMA3 */
#define INTNO_TA0    	12	/* ^C}A0 */
#define INTNO_TA1    	13	/* ^C}A1 */
#define INTNO_TA2    	14	/* ^C}A2 */
#define INTNO_TA3    	15	/* ^C}A3 */
#define INTNO_TA4    	16	/* ^C}A4 */
#define INTNO_S0TNACK	17	/* UART0M,NACK */
#define INTNO_S0RACK 	18	/* UART0M,ACK */
#define INTNO_S1TNACK	19	/* UART1M,NACK */
#define INTNO_S1RACK 	20	/* UART1M,ACK */
#define INTNO_TB0    	21	/* ^C}B0 */
#define INTNO_TB1    	22	/* ^C}B1 */
#define INTNO_TB2    	23	/* ^C}B2 */
#define INTNO_TB3    	24	/* ^C}B3 */
#define INTNO_TB4    	25	/* ^C}B4 */
#define INTNO_INT5   	26	/* INT5 */
#define INTNO_INT4   	27	/* INT4 */
#define INTNO_INT3   	28	/* INT3 */
#define INTNO_INT2   	29	/* INT2 */
#define INTNO_INT1   	30	/* INT1 */
#define INTNO_INT0   	31	/* INT0 */
#define INTNO_TB5    	32	/* ^C}B5 */
#define INTNO_S2TNACK	33	/* UART2M,NACK */
#define INTNO_S2RACK 	34	/* UART2M,ACK */
#define INTNO_S3TNACK	35	/* UART3M,NACK */
#define INTNO_S3RACK 	36	/* UART3M,ACK */
#define INTNO_S4TNACK	37	/* UART4M,NACK */
#define INTNO_S4RACK 	38	/* UART4M,ACK */

#define INTNO_AD0     	42	/* A-Dϊ0 */
#define INTNO_KEY     	43	/* L[͊荞 */
#define INTNO_IIO0    	44	/* CeWFgI/O0 */
#define INTNO_IIO1    	45	/* CeWFgI/O1 */
#define INTNO_IIO2    	46	/* CeWFgI/O2 */
#define INTNO_IIO3    	47	/* CeWFgI/O3 */
#define INTNO_IIO4    	48	/* CeWFgI/O4 */
#define INTNO_IIO5    	49	/* CeWFgI/O5 */
#define INTNO_IIO6    	50	/* CeWFgI/O6 */
#define INTNO_IIO7    	51	/* CeWFgI/O7 */
#define INTNO_IIO8    	52	/* CeWFgI/O8 */
#define INTNO_IIO9CAN0	53	/* CeWFgI/O9,CAN0 */
#define INTNO_IIO10CAN	54	/* CeWFgI/O10,CAN1 */
#define INTNO_IIO11CAN	57	/* CeWFgI/O11,CAN2 */

/*
 *  ݃nhԍ̒`
 */
#define	INHNO_BRK    	INTNO_BRK    	/* BRK */
                        
#define INHNO_AD1    	INTNO_AD1    	/* A-Dϊ1 */
#define INHNO_DMA0   	INTNO_DMA0   	/* DMA0 */
#define INHNO_DMA1   	INTNO_DMA1   	/* DMA1 */
#define INHNO_DMA2   	INTNO_DMA2   	/* DMA2 */
#define INHNO_DMA3   	INTNO_DMA3   	/* DMA3 */
#define INHNO_TA0    	INTNO_TA0    	/* ^C}A0 */
#define INHNO_TA1    	INTNO_TA1    	/* ^C}A1 */
#define INHNO_TA2    	INTNO_TA2    	/* ^C}A2 */
#define INHNO_TA3    	INTNO_TA3    	/* ^C}A3 */
#define INHNO_TA4    	INTNO_TA4    	/* ^C}A4 */
#define INHNO_S0TNACK	INTNO_S0TNACK	/* UART0M,NACK */
#define INHNO_S0RACK 	INTNO_S0RACK 	/* UART0M,ACK */
#define INHNO_S1TNACK	INTNO_S1TNACK	/* UART1M,NACK */
#define INHNO_S1RACK 	INTNO_S1RACK 	/* UART1M,ACK */
#define INHNO_TB0    	INTNO_TB0    	/* ^C}B0 */
#define INHNO_TB1    	INTNO_TB1    	/* ^C}B1 */
#define INHNO_TB2    	INTNO_TB2    	/* ^C}B2 */
#define INHNO_TB3    	INTNO_TB3    	/* ^C}B3 */
#define INHNO_TB4    	INTNO_TB4    	/* ^C}B4 */
#define INHNO_INT5   	INTNO_INT5   	/* INT5 */
#define INHNO_INT4   	INTNO_INT4   	/* INT4 */
#define INHNO_INT3   	INTNO_INT3   	/* INT3 */
#define INHNO_INT2   	INTNO_INT2   	/* INT2 */
#define INHNO_INT1   	INTNO_INT1   	/* INT1 */
#define INHNO_INT0   	INTNO_INT0   	/* INT0 */
#define INHNO_TB5    	INTNO_TB5    	/* ^C}B5 */
#define INHNO_S2TNACK	INTNO_S2TNACK	/* UART2M,NACK */
#define INHNO_S2RACK 	INTNO_S2RACK 	/* UART2M,ACK */
#define INHNO_S3TNACK	INTNO_S3TNACK	/* UART3M,NACK */
#define INHNO_S3RACK 	INTNO_S3RACK 	/* UART3M,ACK */
#define INHNO_S4TNACK	INTNO_S4TNACK	/* UART4M,NACK */
#define INHNO_S4RACK 	INTNO_S4RACK 	/* UART4M,ACK */

#define INHNO_AD0     	INTNO_AD0     	/* A-Dϊ0 */
#define INHNO_KEY     	INTNO_KEY     	/* L[͊荞 */
#define INHNO_IIO0    	INTNO_IIO0    	/* CeWFgI/O0 */
#define INHNO_IIO1    	INTNO_IIO1    	/* CeWFgI/O1 */
#define INHNO_IIO2    	INTNO_IIO2    	/* CeWFgI/O2 */
#define INHNO_IIO3    	INTNO_IIO3    	/* CeWFgI/O3 */
#define INHNO_IIO4    	INTNO_IIO4    	/* CeWFgI/O4 */
#define INHNO_IIO5    	INTNO_IIO5    	/* CeWFgI/O5 */
#define INHNO_IIO6    	INTNO_IIO6    	/* CeWFgI/O6 */
#define INHNO_IIO7    	INTNO_IIO7    	/* CeWFgI/O7 */
#define INHNO_IIO8    	INTNO_IIO8    	/* CeWFgI/O8 */
#define INHNO_IIO9CAN0	INTNO_IIO9CAN0	/* CeWFgI/O9,CAN0 */
#define INHNO_IIO10CAN	INTNO_IIO10CAN	/* CeWFgI/O10,CAN1 */
#define INHNO_IIO11CAN	INTNO_IIO11CAN	/* CeWFgI/O11,CAN2 */

/*
 *  ݐ䃌WX^`
 */
#define TADR_TA0IC		(0x6C)
#define TADR_TA1IC		(0x8C)
#define TADR_TA2IC		(0x6E)
#define TADR_TA3IC		(0x8E)
#define TADR_TA4IC		(0x70)
#define TADR_TB0IC		(0x94)
#define TADR_TB1IC		(0x76)
#define TADR_TB2IC		(0x96)
#define TADR_TB3IC		(0x78)
#define TADR_TB4IC		(0x98)
#define TADR_TB5IC		(0x69)
#define TADR_S0TIC		(0x90)
#define TADR_S1TIC		(0x92)
#define TADR_S2TIC		(0x89)
#define TADR_S3TIC		(0x8B)
#define TADR_S4TIC		(0x8D)
#define TADR_S0RIC		(0x72)
#define TADR_S1RIC		(0x74)
#define TADR_S2RIC		(0x6B)
#define TADR_S3RIC		(0x6D)
#define TADR_S4RIC		(0x6F)
#define TADR_BCN0IC		(0x71)
#define TADR_BCN1IC		(0x91)
#define TADR_BCN2IC		(0x8F)
#define TADR_BCN3IC		(0x71)
#define TADR_BCN4IC		(0x91)
#define TADR_DMO0IC		(0x68)
#define TADR_DMO1IC		(0x88)
#define TADR_DMO2IC		(0x6A)
#define TADR_DMO3IC		(0x8A)
#define TADR_AD0IC		(0x73)
#define TADR_KUPIC		(0x93)
#define TADR_IIO0IC		(0x75)
#define TADR_IIO1IC		(0x95)
#define TADR_IIO2IC		(0x77)
#define TADR_IIO3IC		(0x97)
#define TADR_IIO4IC		(0x79)
#define TADR_IIO8IC		(0x7D)
#define TADR_IIO9IC		(0x9D)
#define TADR_IIO10IC	(0x7F)
#define TADR_CAN0IC		(0x9D)
#define TADR_CAN1IC		(0x7F)
#define TADR_CAN2IC		(0x81)
#define TADR_CAN3IC		(0x75)
#define TADR_CAN4IC		(0x95)
#define TADR_CAN5IC		(0x99)

#define TADR_INT0IC		(0x9E)
#define TADR_INT1IC		(0x7E)
#define TADR_INT2IC		(0x9C)
#define TADR_INT3IC		(0x7C)
#define TADR_INT4IC		(0x9A)
#define TADR_INT5IC		(0x7A)


/*
 *  TA0֘AWX^(VXeeBbNp)
 */
#define TADR_TABSR			(0x340U)
#define TADR_UDF			(0x344U)
#define TADR_TA0			(0x346)
#define TADR_TA0MR			(0x356)

#define TBIT_TABSR_TA0S	0x01


/*
 *  ėp|[gWX^(ꕔC144sł̂)
 */
#define TBIT_BIT0	0x01
#define TBIT_BIT1	0x02
#define TBIT_BIT2	0x04
#define TBIT_BIT3	0x08
#define TBIT_BIT4	0x10
#define TBIT_BIT5	0x20
#define TBIT_BIT6	0x40
#define TBIT_BIT7	0x80

#define TADR_P0 	0x3e0	/* |[gP0WX^ */
#define TADR_P1 	0x3e1	/* |[gP1WX^ */
#define TADR_PD0	0x3e2	/* |[gP0WX^ */
#define TADR_PD1	0x3e3	/* |[gP1WX^ */
#define TADR_P2 	0x3e4	/* |[gP2WX^ */
#define TADR_P3 	0x3e5	/* |[gP3WX^ */
#define	TADR_PD2	0x3e6	/* |[gP2WX^ */
#define	TADR_PD3	0x3e7	/* |[gP3WX^ */
#define TADR_P4 	0x3e8	/* |[gP4WX^ */
#define	TADR_P5 	0x3e9	/* |[gP5WX^ */
#define	TADR_PD4	0x3ea	/* |[gP4WX^ */
#define	TADR_PD5	0x3eb	/* |[gP5WX^ */
#define TADR_P6 	0x3c0	/* |[gP6WX^ */
#define	TADR_P7 	0x3c1	/* |[gP7WX^ */
#define	TADR_PD6	0x3c2	/* |[gP6WX^ */
#define	TADR_PD7	0x3c3	/* |[gP7WX^ */
#define	TADR_P8 	0x3c4	/* |[gP8WX^ */
#define TADR_P9 	0x3c5	/* |[gP9WX^ */
#define	TADR_PD8	0x3c6	/* |[gP8WX^ */
#define TADR_PD9	0x3c7	/* |[gP9WX^ */
#define TADR_P10	0x3c8	/* |[gP10WX^ */
#define TADR_P11	0x3c9	/* |[gP11WX^(144sł̂) */
#define TADR_PD10	0x3ca	/* |[gP10WX^ */
#define TADR_PD11	0x3cb	/* |[gP11WX^(144sł̂) */
#define TADR_P12	0x3cc	/* |[gP12WX^(144sł̂) */
#define TADR_P13	0x3cd	/* |[gP13WX^(144sł̂) */
#define TADR_PD12	0x3ce	/* |[gP12WX^(144sł̂) */
#define TADR_PD13	0x3cf	/* |[gP13WX^(144sł̂) */
#define TADR_P14	0x3d0	/* |[gP14WX^(144sł̂) */
#define TADR_P15	0x3d1	/* |[gP15WX^(144sł̂) */
#define TADR_PD14	0x3d2	/* |[gP14WX^(144sł̂) */
#define TADR_PD15	0x3d3	/* |[gP15WX^(144sł̂) */

#define	TADR_PUR0	0x3f0	/* vAbv䃌WX^O */
#define	TADR_PUR1	0x3f1	/* vAbv䃌WX^P */
#define	TADR_PUR2	0x3da	/* vAbv䃌WX^Q */
#define	TADR_PUR3	0x3db	/* vAbv䃌WX^R */
#define	TADR_PUR4	0x3dc	/* vAbv䃌WX^S(144sł̂) */

#define	TADR_PCR	0x3ff	/* |[g䃌WX^ */

#define TADR_PS0	0x3b0	/* @\IWX^A0 */
#define TADR_PS1	0x3b1	/* @\IWX^A1 */
#define TADR_PS2	0x3b4	/* @\IWX^A2 */
#define TADR_PS3	0x3b5	/* @\IWX^A3 */
#define TADR_PS5	0x3b9	/* @\IWX^A5(144sł̂) */
#define TADR_PS6	0x3bc	/* @\IWX^A6(144sł̂) */
#define TADR_PS7	0x3bd	/* @\IWX^A7(144sł̂) */
#define TADR_PS8	0x3a0	/* @\IWX^A8(144sł̂) */
#define TADR_PS9	0x3a1	/* @\IWX^A9(144sł̂) */

#define TADR_PSL0	0x3b2	/* @\IWX^B0 */
#define TADR_PSL1	0x3b3	/* @\IWX^B1 */
#define TADR_PSL2	0x3b6	/* @\IWX^B2 */
#define TADR_PSL3	0x3b7	/* @\IWX^B3 */

#define TADR_PSC	0x3af	/* @\IWX^C */


#endif	/* TOPPERS_M32C87_H */
