/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2008 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */
/* Copyright(C)2014 by Dr.OGAWA Kiyoshi, MISRAC Stydy Group/SESSAME/Japan
 * misrac1998̌ɊÂĉMmisrac:1998ƋLځB
 * misrac2004, misrac2012̌ʂɂĂ͉MO̕悢ꍇB
 * r̂߂ɋLqBłɍ̗pꍇɁAes̒LĂ悢B
 */ 
/*
 *		sil.h vZbTˑ(M16Ct@~ʕ)
 */

#ifndef TOPPERS_PRC_SIL_H
#define TOPPERS_PRC_SIL_H

#ifndef TOPPERS_MACRO_ONLY
#include "prc_insn.h"

Inline uint16_t TOPPERS_disint(void);/* misrac:1998 rule71 prototype*/
Inline void TOPPERS_enaint(uint16_t TOPPERS_flg);/* misrac:1998 rule71 prototype*/

/*
 *  NMIׂĂ݂̊̋֎~
 */
Inline uint16_t
TOPPERS_disint(void)
{
	volatile uint16_t	TOPPERS_flg;

	Asm("	stc flg, $$[FB]", TOPPERS_flg);
	Asm("	fclr i");
	return(TOPPERS_flg);
}

/*
 *  ݗDx}XNi\ǰݒl̐ݒ
 */
Inline void
TOPPERS_enaint(uint16_t TOPPERS_flg)
{
	if(TOPPERS_flg & FLG_I_MASK)/* misra1998: rule 36 '&' and rule 49 non-boolean*, deviation */
	{
		Asm("	fset i");
	}
}

/*
 *  S݃bNԂ̐
 */
#define SIL_PRE_LOC		uint16_t TOPPERS_i_flg;
#define SIL_LOC_INT()	((void)(TOPPERS_i_flg = TOPPERS_disint()))
#define SIL_UNL_INT()	(TOPPERS_enaint(TOPPERS_i_flg))

/*
 *  ԑ҂
 */
extern void sil_dly_nse(ulong_t dlytim);

#endif /* TOPPERS_MACRO_ONLY */

/*
 *  vZbT̃GfBA
 */
#define SIL_ENDIAN_LITTLE			/* gGfBA */

#endif /* TOPPERS_PRC_SIL_H */
