/*
 *  TOPPERS/SSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 		 serial.h 
 */
/* Copyright(C)2014 by Dr.OGAWA Kiyoshi, MISRAC Stydy Group/SESSAME/Japan
 * misrac1998̌ɊÂĉMmisrac:1998ƋLځB
 * misrac2004, misrac2012̌ʂɂĂ͉MO̕悢ꍇB
 * r̂߂ɋLqBłɍ̗pꍇɁAes̒LĂ悢B
 */ 
/*
 *		VAC^tF[XhCo
 */

#ifndef TOPPERS_SERIAL_H
#define TOPPERS_SERIAL_H

#ifdef __cplusplus
extern "C" {
#endif

#include "target_syssvc.h"
#include "target_serial.h"

/*
 *  VAC^tF[XhCo̗ppPbg
 */
typedef struct {
	uint_t		reacnt;			/* Mobt@̕ */
	uint_t		wricnt;			/* Mobt@̕ */
} T_SERIAL_RPOR;

/*
 *  obt@TCỸftHglƃobt@̒`
 */
#ifndef SERIAL_RCV_BUFSZ1
#define	SERIAL_RCV_BUFSZ1	64			/* |[g1̎Mobt@TCY */
#endif /* SERIAL_RCV_BUFSZ1 */

#ifndef SERIAL_SND_BUFSZ1
#define	SERIAL_SND_BUFSZ1	64			/* |[g1̑Mobt@TCY */
#endif /* SERIAL_SND_BUFSZ1 */

static char_t	rcv_buffer1[SERIAL_RCV_BUFSZ1];
static char_t	snd_buffer1[SERIAL_SND_BUFSZ1];

#if TNUM_PORT >= 2						/* |[g2Ɋւ` */

#ifndef SERIAL_RCV_BUFSZ2
#define	SERIAL_RCV_BUFSZ2	64			/* |[g2̎Mobt@TCY */
#endif /* SERIAL_RCV_BUFSZ2 */

#ifndef SERIAL_SND_BUFSZ2
#define	SERIAL_SND_BUFSZ2	64			/* |[g2̑Mobt@TCY */
#endif /* SERIAL_SND_BUFSZ2 */

static char_t	rcv_buffer2[SERIAL_RCV_BUFSZ2];
static char_t	snd_buffer2[SERIAL_SND_BUFSZ2];

#endif /* TNUM_PORT >= 2 */

#if TNUM_PORT >= 3						/* |[g3Ɋւ` */

#ifndef SERIAL_RCV_BUFSZ3
#define	SERIAL_RCV_BUFSZ3	64			/* |[g3̎Mobt@TCY */
#endif /* SERIAL_RCV_BUFSZ3 */

#ifndef SERIAL_SND_BUFSZ3
#define	SERIAL_SND_BUFSZ3	64			/* |[g3̑Mobt@TCY */
#endif /* SERIAL_SND_BUFSZ3 */

static char_t	rcv_buffer3[SERIAL_RCV_BUFSZ3];
static char_t	snd_buffer3[SERIAL_SND_BUFSZ3];

#endif /* TNUM_PORT >= 3 */

/*
 *  VA|[gubN
 */
typedef struct serial_port_initialization_block {
	uint_t	rcv_bufsz;		/* Mobt@TCY */
	char_t	*rcv_buffer;	/* Mobt@ */
	uint_t	snd_bufsz;		/* Mobt@TCY */
	char_t	*snd_buffer;	/* Mobt@ */
} SPINIB;

static const SPINIB spinib_table[TNUM_PORT] = {
	{ SERIAL_RCV_BUFSZ1, rcv_buffer1,
	  SERIAL_SND_BUFSZ1, snd_buffer1 },
#if TNUM_PORT >= 2
	{ SERIAL_RCV_BUFSZ2, rcv_buffer2,
	  SERIAL_SND_BUFSZ2, snd_buffer2 },
#endif /* TNUM_PORT >= 2 */
#if TNUM_PORT >= 3
	{ SERIAL_RCV_BUFSZ3, rcv_buffer3,
	  SERIAL_SND_BUFSZ3, snd_buffer3 },
#endif /* TNUM_PORT >= 3 */
};

/*
 *  VA|[gǗubN
 */
typedef struct serial_port_control_block {
	const SPINIB *p_spinib;		/* VA|[gubN */
	SIOPCB	*p_siopcb;			/* VAI/O|[gǗubN */
	bool_t	openflag;			/* I[vς݃tO */
	bool_t	errorflag;			/* G[tO */
	uint_t	ioctl;				/* 쐧̐ݒl */

	uint_t	rcv_read_ptr;		/* Mobt@Ǐo|C^ */
	uint_t	rcv_write_ptr;		/* Mobt@݃|C^ */
	uint_t	rcv_count;			/* Mobt@̕ */

	uint_t	snd_read_ptr;		/* Mobt@Ǐo|C^ */
	uint_t	snd_write_ptr;		/* Mobt@݃|C^ */
	uint_t	snd_count;			/* Mobt@̕ */
} SPCB;

static SPCB	spcb_table[TNUM_PORT];


/*
 *  VAC^tF[XhCȍ[`
 */
extern void		serial_initialize(intptr_t exinf);

/*
 *  VAC^tF[XhCȍI[`
 */
extern void		serial_terminate(intptr_t exinf);

/*
 *  VAC^tF[XhCo̖M̎o
 */
extern bool_t	serial_get_chr(ID portid, char_t *p_c);

/*
 *  VAC^tF[XhCõT[rXR[
 */
extern ER		serial_opn_por(ID portid);
extern ER		serial_cls_por(ID portid);
extern ER_UINT	serial_rea_dat(ID portid, char_t *buf, uint_t len);
extern ER_UINT	serial_wri_dat(ID portid, const char_t *buf, uint_t len);
extern ER		serial_ctl_por(ID portid, uint_t ioctl);

/*
 *  VAC^tF[XhCo̓쐧p̂߂̒萔
 *
 *  ȉ̒萔́Crbgɘ_aƂėpD
 */
#define	IOCTL_NULL	0U			/* wȂ */
#define	IOCTL_ECHO	0x0001U		/* MGR[obN */
#define	IOCTL_CRLF	0x0010U		/* LF𑗐MOCRt */

static ER gen_ercd_sys(SPCB *p_spcb);/* misrac:1998 rule 71 prototype */

Inline bool_t serial_snd_chr(SPCB *p_spcb, char_t c);

static ER_BOOL serial_wri_chr(SPCB *p_spcb, char_t c);

extern bool_t serial_sndbuf_full(SPCB *p_spcb);

extern bool_t serial_rcvbuf_empty(SPCB *p_spcb);
static bool_t serial_rea_chr(SPCB *p_spcb, char_t *p_c);
static bool_t serial_rea_chr(SPCB *p_spcb, char_t *p_c);

#ifdef __cplusplus
}
#endif

#endif /* TOPPERS_SERIAL_H */
